;************************************************************************;
;*								       	*;
;*	Copyright JK microsystems 1995	-  All Rights Reserved	  	*;
;*									*;
;*	This software is NOT shareware, freeware, or public domain.	*;
;*	It is the property of JK microsystems.				*;
;*									*;
;*	Customers of JK microsystems may modify the source code		*; 
;*	and/or distribute the binary image of this software without 	*;
;*	additional costs  All other use is expressly prohibited.	*;
;*									*;
;*	Update Log							*;
;*									*;
;*	Version	Date	Comments			Progammer	*;
;*	-------	-------	-------------------------------	----------	*;
;*	1.00	3/3/3	Initial Release			Bob Perrin      *;
;*									*;
;************************************************************************;

	page	60,132
Code_seg	Segment
	assume	cs:code_seg,ds:code_seg,ss:code_seg

	
	org	100h
start:
	mov	ax,cs
	mov	ds,ax
	mov	ss,ax
	mov	sp,0ffffh

;	user code follows

	call	print_crlf

	mov	ch,0			; zero upper byte of CX
	mov	si,80h			; point to cmd line length
	mov	cl,[si]			; get it
	cmp	cl,0			; zero if no command tail
	je	failed			; show the fool how to do it
	jmp	get_cmd_tail		; got a command tail, use it

failed:
	call	print_next
	db	'PowerNut Communications Utility for Flashlite 186', 0Dh, 0Ah
	db	'Version 1.0 - see www.jkmicro.com for updates',0Dh,0Ah
	db	0Dh,0Ah
        db      '  Usage: nutcomm <command> <param>',0Dh,0Ah
	db	'  commands - sleep, config, lptest ', 0Dh,0Ah
	db	'  param - hex value between 0000 and FFFF', 0Dh, 0Ah, 0Dh, 0Ah
        db      '  EXAMPLE "nutcomm sleep, 000A" - means sleep for 10 seconds', 0Dh, 0Ah
	db	0Dh,0Ah
	db	'  Required electrical connections:', 0Dh, 0Ah
	db	'    Flashlite 186 J9:1  to PowerNut GND (J3:1)',0Dh,0Ah
	db	'    Flashlite 186 J9:5  to PowerNut CLK (J3:4)',0Dh,0Ah
	db	'    Flashlite 186 J9:10 to PowerNut DATA_IO (J3:3)',0Dh,0Ah,0

	call	print_crlf
	mov	ax,4C01h
	int	21h

get_cmd_tail:
	add	si,2			; space forward to first char of tail

;	At this point, we know we have a command tail.  DS:SI points
;	to it and CX has the count of chars in it.  First we will try
;	to match the command in the tail with the three possible valid
;	commands that we've implemented

	mov	di,offset sleep_cmd	; point to sleep_cmd
	call	test_cmd		; and test for it

	jc	failed_sleep
	mov	byte ptr [cmd_byte],1
	jmp	cmd_done

failed_sleep:
	mov	di,offset config_cmd	; point to config_cmd
	call	test_cmd		; and test for it
	jc	failed_config
	mov	byte ptr [cmd_byte],2
	jmp	cmd_done

failed_config:
	mov	di,offset lobat_cmd	; point to lobat_cmd
	call	test_cmd		; and test for it
	jnc	lobat_passed

        mov     di,offset nop_cmd       ; point to nop
	call	test_cmd		; and test for it
	jnc	nop_passed
	jmp	failed

nop_passed:
	call	print_next
        db      'Nothing happens.', 0Dh, 0Ah, 00h

	mov	ax,4C00h
	int	21h

	jmp	failed
lobat_passed:
	mov	byte ptr [cmd_byte],5

cmd_done:
	mov	al,byte ptr [cmd_byte]

;	We've got a good command, now we need to get the hex parameter
;	code

	mov	al,byte ptr [si]
	cmp	al,0Dh				; is the next char CR?
	jne	check_space
	jmp	failed				; no param, fail action
check_space:
	cmp	al,20h				; is next char space?
	je	get_param
	jmp	failed				; no, fail him

get_param:
	inc	si				; get first char of alleged
	mov	di,offset digit_1		; store up to 4 good digits
	mov	cx,4				; max digit count
get_digit_loop:
	mov	al,[si]				; get a digit
	call	test_and_convert		; try to convert it to binary
	jc	convert_done			; carry is set if not valid
	mov	byte ptr [di],al		; carry cleared, store value
	inc	di				; bump pointers
	inc	si
	loop	get_digit_loop

;	we've got between 1 and 4 binary numbers in digit_1 to digit_4
;	now we have to pack them to a single 16-bit value.
				
convert_done:
	mov	bx,0				; pack number here
	mov	cx,4				; four digits to scale and sum
	mov	si,offset digit_1		; start with most significant
pack_loop:
	mov	al,byte ptr [si]		; get it
	inc	si				; bump pointer
	cmp	al,0FFh				; was anything put in it?
	je	pack_done			; yes, get ready to pack it
good_digit:
	shl	bx,1
	shl	bx,1
	shl	bx,1
	shl	bx,1
	or	bl,al				; OR it into bx
	loop	pack_loop

pack_done:
	mov	word ptr [param_word],bx

	call	initialize_io

	call	cal_delay			;Figure out good clock delay

;compute PARTITY now

	mov	cx, 0010h
	mov 	word ptr [temp_parity], 0000h
	mov	ax, word ptr [param_word]
data_parity:
	xor	word ptr [temp_parity], ax
	ror	ax, 01h
	loop data_parity

	mov	cx, 0003h
	mov	al, byte ptr [cmd_byte]
cmd_parity:
	xor	word ptr [temp_parity], ax
	ror	ax, 01h
	loop cmd_parity

	and	word ptr [temp_parity], 0001h

	call	print_next
	db	'PowerNut Communications Utility for Flashlite 186',0
	call	print_crlf
	call	print_crlf

	mov	al, byte ptr [cmd_byte]
	and	al,7
	mov	ah,0
        rcr     word ptr [temp_parity], 1
        rcl     ax,1
	mov	byte ptr [cmd_byte], al		;store cmd+parity in cmd_byte

	mov	di, word ptr [param_word]
	mov	ah, 00h
	mov	al, byte ptr [cmd_byte]
	mov	si, ax

	call	powernut_xmit		; si = cmd+parity, di = data

	cmp	ack_nack, 00h
	jz	first_nack

	call	print_next
	db	'Received ACK - communication successful.',0

	mov	ax,4C00h		;TERMINATE PROGRAM RETURN 00 - success!
	int	21h

first_nack:
	;back off for one second and retry transmission

	call	wait_a_second

	mov	di, word ptr [param_word]
	mov	ah, 00h
	mov	al, byte ptr [cmd_byte]
	mov	si, ax
	
	call	powernut_xmit		; si = cmd+parity, di = data

	cmp	ack_nack, 00h
	jz	second_nack

	call	print_next
	db	'Received ACK after one retry - communication successful.',0

	mov	ax,4C00h		;TERMINATE PROGRAM RETURN 00 - success!
	int	21h

second_nack:

	call	print_next
	db	'Received NACK, retried once, received second NACK.', 0Dh, 0Ah
	db	'Communication FAILED.',0

	mov	ax,4C01h		;TERMINATE PROGRAM RETURN 01 - error!
	int	21h
	
powernut_xmit:
	call	clear_data
	call	delay
	call	set_clk
	call	delay
	call	clear_clk
        mov     cx,4

cmd_loop:
	rcr	si,1		
	jc	cmd_1
	call	clear_data
	call	delay
	call	set_clk
	call	delay
	call	clear_clk
	loop	cmd_loop
	jmp	do_data
cmd_1:
	call	set_data
	call	delay
	call	set_clk
	call	delay
	call	clear_clk
	loop	cmd_loop
do_data:
	mov	cx,16
data_loop:
	rcr	di,1		
	jc	data_1
	call	clear_data
	call	delay
	call	set_clk
	call	delay
	call	clear_clk
	loop	data_loop
	jmp	loop_done
data_1:
	call	set_data
	call	delay
	call	set_clk
	call	delay
	call	clear_clk
	loop	data_loop
	call 	clear_clk
	call	clear_data

loop_done:
        call    make_data_an_input
        call    delay
        call    set_clk
        call    delay
	
	call	read_data_io		;LSB of ax has value on return
	mov	byte ptr [ack_nack], al

        call    clear_clk

        call    delay
        call    make_data_an_output
        call    set_data                ;start-bits are low, so leave
                                        ;data high.
	ret

ack_nack	db  00h


test_and_convert:
	mov	bx,offset convert_table	; point bx to conversion table
	xlat				; do it
	cmp	al,0FFh			; is it valid hex number?
	je	convert_error		; no, set carry
	clc				; yes, clear carry
	ret
convert_error:
	stc
	ret





test_cmd:
	push	si			; save pointer
	push	cx			; and count in case we fail
test_cmd_loop:
	mov	al,ds:[si]		; get cmd tail char
	or 	al,20h			; force char to lower case
	mov	ah,ds:[di]		; get check char
	cmp	ah,0			; it it null terminator?
	je	test_cmd_passed		; yes, we've successfully tested it
	inc	si			; no, bump pointers
	inc	di			; so we can test the rest
	cmp	al,ah			; is cmd tail and check char the same?
	je	test_cmd_loop		; yes, check the whole thing
	pop	cx			; no, return with carry set
	pop	si
	stc
	ret

test_cmd_passed:
	pop	ax			; don't pop into cx, we'll need it
	pop	ax
	clc
	ret
		
	
convert_table:
		db	30h	dup (0FFh)	; 00-2F, all invalid
		db	0,1,2,3,4,5,6,7,8,9	; 30-39, convert 0-9
		db	7	dup (0FFh)	; 3A-40, all invalid
		db	10,11,12,13,14,15	; 41-46, convert A-F
		db	26	dup (0FFh)	; 47-60, all invalid
		db	10,11,12,13,14,15	; 61-66, convert a-f
		db	153	dup (0FFh)	; 67-FF, all invalid

digit_1		db	0FFh
digit_2		db	0FFh
digit_3		db	0FFh
digit_4		db	0FFh

cmd_byte	db	0FFh
param_word	dw	0FFFFh
sleep_cmd	db	'sleep',0
config_cmd	db	'config',0
lobat_cmd	db	'lptest',0
nop_cmd         db      'xyzzy',0

wait_a_second:
	push	ds			; point ds to bios data
	mov	ax,40h
	mov	ds,ax
	mov	di,offset 6Ch		; point di to tick increment
	
	mov	ah,[di]			; sync with tick transitions
first_click:	
	align	2
	mov	al,[di]
	cmp	al,ah
	je	first_click

	mov	cx, 12h			; cx has loop count
look_a_new_tick:
	mov	ah,[di]
look_a_tick:
	align	2
	mov	al,[di]
	cmp	al,ah
	je	look_a_tick
	loop look_a_new_tick

	pop	ds
	ret

cal_delay:
	push	ds			; point ds to bios data
	mov	ax,40h
	mov	ds,ax
	mov	di,offset 6Ch		; point di to tick increment
	
	mov	ah,[di]			; sync with tick transitions
first_transition:	
	align	2
	mov	al,[di]
	cmp	al,ah
	je	first_transition

	mov	cx,0			; cx has loop count
	mov	ah,[di]
second_transition:
	align	2
	nop
	inc	cx
	mov	al,[di]
	cmp	al,ah
	je	second_transition

	pop	ds
	shr	cx,1			; divide constant by 2
	and	cx,7FFFh		; blow away high bit
	mov	word ptr [delay_count],cx 
	ret

delay_count	dw	?
temp_parity     dw      ?

delay:
	push	cx
	mov	cx,word ptr[delay_count]
delay_loop:
	align	2
	mov	al,[di]
	dec	cx
	jnz	delay_loop
	pop	cx
	ret

	include	186_io.asm


;---------------------------------------------------------------
;
;	Prints the character passed in AL to the display
;
Print_char:
	mov	ah,0Eh
	int	10h
	ret				; go back

;---------------------------------------------------------------
;
;	Prints the null terminated string pointed to by SI
;
Print_string:
	push	ax			; save registers
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	
String_loop:
	mov	al,[si]			; get the char
	cmp	al,0			; end?
	jz 	string_done		; yes
	inc	si			; no, bump pointer
	push 	si			; save it
	mov 	ah,0Eh			; print char
	int	10h
	pop	si
	jmp	string_loop

String_done:
	pop	bp			; restore registers
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax

	ret				; go back

;---------------------------------------------------------------
;
;	Do a print_string and then a CRLF
;
Print_string_crlf:
	call 	print_string
	push	ax
	mov	al,0Dh
	call	print_char
	mov	al,0Ah
	call	print_char
	pop	ax
	ret

;---------------------------------------------------------------
;
;	Print a CRLF
;
Print_crlf:
	push	ax
	mov	al,0Dh
	call	print_char
	mov	al,0Ah
	call	print_char
	pop	ax
	ret

;---------------------------------------------------------------
;
; 	Print the contents of AL as a 2 char hex string
;
Print_hex_byte:
	push	cx			; save trashed registers
	push	ax			
	push	ax			; save ax locally
	
	and	al,0F0h			; zero the low nibble
	mov	cl,4			; shift over the hi nibble
	shr	al,cl
	cmp	al,0Ah			; is it A-F?
	js	its_0_9			; no
	add	al,7			; adjust it up

its_0_9:
	add	al,30h			; make everybody ascii
	call	print_char		; print it
	pop	ax			; start on the low byte
	and	al,0Fh			; zero the low nibble
	cmp	al,0Ah			; is it A-F?
	js	its_0_9_again		; no
	add	al,7			; adjust it up

its_0_9_again:
	add	al,30h			; make everybody ascii
	call	print_char		; print it
	pop	ax			; start on the low byte
	pop	cx
	
	ret

;------------------------------------------------------------------
;
;	This routine will take the value in al and print it
;	as an eight digit binary value.
;
Print_binary_byte:
	push 	ax			; save the value
	push	bx
	push	cx
	mov	bl,al
	mov	cx,8			; our loop counter, 8 bits
binary_loop:
	rcl	bl,1			; get the next bit in carry
	jc	one
	mov	al,'0'
	call 	Print_char
	jmp	around_one
one:
	mov	al,'1'
	call	Print_char
around_one:
	dec	cx
	jnz	binary_loop
	pop	cx
	pop	bx
	pop	ax
	ret

;---------------------------------------------------------------
;
; 	Print the contents of AX as a 4 char hex string		
;
Print_hex_word:
	push	ax
	mov	al,ah
	call	Print_hex_byte
	pop	ax
	call	Print_hex_byte
	ret

;---------------------------------------------------------------
;
;	Prints the ASCIIZ string that immediately follows the call
;	to this subroutine.  Continue execution after the string
;	and null terminator.  
;
;	Caution!  This routine must be invoked with a near call.
;		  To work with a far call, you must modify it to 
;		  address the string off of the pushed CS and 
;		  adjust the index into the stack to account for
;		  the additional word pushed.
;
Print_next:
	pushf				; save flags
	push	ax			; save registers
	push	bx
	push	cx
	push	dx
	push	si
	push	di
	push	bp
	push	es
	push	ds
	
	mov	bp,sp
	add	bp,14h			; point to "return"
	mov	si,ss:[bp]		; get it in SI

print_loop:
	mov	al,cs:[si]		; get the char
	cmp	al,0			; end?
	jz 	print_done		; yes
	inc	si			; no, bump pointer
	push 	si			; save it
	push	bp
	mov 	ah,0Eh			; print char
	int	10h
	pop	bp
	pop	si
	jmp	print_loop

print_done:
	inc	si			; go past null terminator
	mov	ss:[bp],si		; plug in new return

	pop	ds			; restore registers
	pop	es
	pop	bp
	pop	di
	pop	si
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	popf
	ret				; go back

;---------------------------------------------------------------
;
;	Check for key hit, if none, return.  If hit, exit to DOS
;	
key_hit:
	push	ax
	mov	ah,1			; check for key hit
	int	16h
	pop	ax
	jz	no_hit			; no, back to caller
	mov	ah,0			; yes, swallow char so COMMAND.COM
	int	16h			; doesn't echo it
quit:
	mov	ax,4C00h		; back to dos
	int	21h
no_hit:
	ret				

;---------------------------------------------------------------
;
;
get_char:
	push	bx
	push	ax
	mov	ah,0
	int	16h
	push	ax
	mov	ah,0Eh
	int	10h
	pop	ax
	mov	bl,al
	pop	ax
	mov	al,bl
	pop	bx
	ret


;---------------------------------------------------------------
;
;	Print AL as a 2 char decimal number.  Return with no
;	action if AL > 99d.
;
print_decimal_byte:
	cmp	al,99			; is it above 99?
	ja	bad_decimal_number	; yes, leave
	push	ax			; no, save some registers
	push	si
	mov	si,offset decimal_table	; point to the translate table
	mov	ah,0
	sal	ax,1			; multiply the value by 2	
	add	si,ax			; offset into the table address
	mov	al,[si]			; get the first char
	call	print_char		; print it
	mov	al,[si+1]		; get the second char
	call	print_char		; print it
	pop	si			; restore the registers
	pop	ax
bad_decimal_number:
	ret

;------------------------------------------------------------------
;
;	This routine will get a maximum of 4 hex char from
;	the keyboard and convert them into a binary word in DI
;	Carry flag will be set if user terminates string with
;	a CR, cleared if terminated with SP, comma, or period.
;
get_hex_word:
	push	ax
	push	dx
	push	cx
	mov	dx,0			; we will build the word here
	call	get_hex			; get the first digit
	cmp	al,0ffh			; was it CR
	jz	gotwordCR		; yes, leave
	or	dl,al			; no, put it in dl
	call	get_hex			; next char
	cmp	al,0ffh			; was it CR
	jz	gotwordCR		; yes, leave
	mov	cl,4			; shift over dx
	shl	dx,cl			; for the next digit
	or	dl,al			; OR it in	
	call	get_hex			; next char
	cmp	al,0ffh			; was it CR
	jz	gotwordCR		; yes, leave
	mov	cl,4			; shift over dx
	shl	dx,cl			; for the next digit
	or	dl,al			; OR it in	
	call	get_hex			; next char
	cmp	al,0ffh			; was it CR
	jz	gotwordCR		; yes, leave
	mov	cl,4			; shift over dx
	shl	dx,cl			; for the next digit
	or	dl,al			; OR it in	
	call	get_hex			; next char

	clc
	mov	di,dx			; get it in di
	pop	cx
	pop	dx
	pop	ax
	ret	
gotwordCR:
	stc
	mov	di,dx			; get it in di
	pop	cx
	pop	dx
	pop	ax
	ret	

;------------------------------------------------------------------
;
;	This routine gets a char from serial port 0,
;	tests to see if it is a valid hex char and ignores it
;	if it isn't.  If it is, the raw char is echod, and the
;	char is converted to 4 bit binary in bits 3-0 of al.
;	A CR is treated special, al is set to FFh and the 
;	caller returned to.
;
get_hex:
	push	bx			; save bx
	mov	bh,ah			; save ah
gethex2:
	call	get_char		; get a raw char
	cmp	al,0Dh			; was it CR
	jz	getoutnow		; yes, read the label
	cmp	al," "			; was it space?
	jz 	getoutnow		; yes, leave
	cmp	al,"."			; was it period?
	jz	getoutnow		; yes, leave
	cmp	al,","			; was it comma
	jz	getoutnow		; yes, leave
	mov	bl,al			; preserve it for echo
	cmp	al,30h			; is it less than 30h?
	js	trashit			; yes, get another
	cmp	al,3ah			; is it less than 3Ah
	js	goodchar		; it's between 0-9
	cmp	al,41h			; is it less than "A"
	js	trashit			; yes, invalid, get another
	cmp	al,47h			; is it less than "G"
	js	goodchar		; yes, it's between A-F 
	cmp	al,61h			; is it valid lower case?
	js	trashit			; no, get another
	cmp	al,67h			; yes, is it between a-f?
	jns	trashit			; no, get another
goodlcasechar:
	sub	al,20h			; yes, convert to upper
goodchar:
	cmp	al,41h			; A-F?
	js	char09			; no
	sub	al,7			; adjust it
char09:
	sub 	al,30h			; finish the conversion
	cmp	al,10h			; is it valid?
	jns	gethex2			; no, ignore and get another
	and	al,0Fh			; kill upper 4 bits
	mov	ah,al			; shuffle things around
	mov	al,bl			; so we can print the
	mov	al,ah			; restore the result
	mov	ah,bh			; restore ah
	pop	bx			; restore bx
	ret				; and leave

getoutnow:
	cmp	al,0dh			; was it CR
	jnz	otherterm		; no, go elsewhere	
	mov	al,0ffh			; mark it as a CR
	mov	ah,bh			; restore ah
	pop	bx			; restore bx
	ret				; and leave
otherterm:
	mov	al,0feh			; mark it as other term
	mov	ah,bh			; restore ah
	pop	bx			; restore bx
	ret				; and leave

trashit:
	mov	al,8
	call	print_char		; send a backspace
	mov	al," "
	call	print_char		; send a space
	mov	al,8
	call	print_char		; and another backspace
	jmp	gethex2			; and try again	




decimal_table:				; Ascii codes of 2 char decimal
	db	'00010203040506070809'	; numbers from 00 to 99
	db	'10111213141516171819'
	db	'20212223242526272829'
	db	'30313233343536373839'
	db	'40414243444546474849'
	db	'50515253545556575859'
	db	'60616263646566676869'
	db	'70717273747576777879'
	db	'80818283848586878889'
	db	'90919293949596979899'

code_seg 	ends

	end	start

